package com.javacodegeeks.basics_of_servlets;

import java.io.IOException;
import java.io.PrintWriter;

import javax.servlet.ServletException;
import javax.servlet.annotation.HttpConstraint;
import javax.servlet.annotation.ServletSecurity;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

// only handles GET requests
@WebServlet("/secure/secureservlet")
// we limit the route to logged in users with role 'admin' for all HTTP methods
@ServletSecurity(value = @HttpConstraint(rolesAllowed = { "admin" }))
public class SecureServlet extends HttpServlet {

    private static final long serialVersionUID = 1L;

    @Override
    protected void doGet(final HttpServletRequest req, final HttpServletResponse resp) throws ServletException, IOException {

        try (PrintWriter writer = resp.getWriter()) {
            resp.setContentType("text/plain");

            // the principal represents the authenticated and authorized user
            // for this route and method
            writer.write(String.format("Feeling secure %s?", req.getUserPrincipal().getName()));
            writer.flush();
        }
    }
}
