package com.javacodegeeks.basics_of_servlets.filters;

import java.io.IOException;

import javax.servlet.Filter;
import javax.servlet.FilterChain;
import javax.servlet.FilterConfig;
import javax.servlet.ServletException;
import javax.servlet.ServletRequest;
import javax.servlet.ServletResponse;
import javax.servlet.annotation.WebFilter;
import javax.servlet.http.HttpServletRequest;

// only relevant on the '/secure/*' route
@WebFilter(urlPatterns = "/secure/*")
public class SessionCreatingFilter implements Filter {

    private static final String AUTH_KEY = "Authorization";

    @Override
    public void init(final FilterConfig filterConfig) throws ServletException {
    }

    @Override
    public void doFilter(final ServletRequest req, final ServletResponse resp, final FilterChain chain) throws IOException, ServletException {
        final HttpServletRequest request = (HttpServletRequest) req;

        // not needed but demonstrates creating a session and putting something
        // in it. Our session attribute listener will receive this event
        request.getSession().setAttribute(AUTH_KEY, request.getUserPrincipal().getName());

        // ensure we continue the filter pipeline, one could also redirect or
        // simply stop the pipeline here
        chain.doFilter(req, resp);
    }

    @Override
    public void destroy() {
    }
}
