package com.javacodegeeks.basics_of_servlets.listeners;

import javax.servlet.ServletRequestEvent;
import javax.servlet.ServletRequestListener;
import javax.servlet.annotation.WebListener;

// a web listener that logs the thread and request URL for all requests into the web application
@WebListener
public class CatchAllServletRequestListener implements ServletRequestListener {

    @Override
    public void requestDestroyed(final ServletRequestEvent sre) {
        System.out.printf("\nThread %s\tRequest destroyed for %s", ListenerHelper.getCurrentThreadName(), ListenerHelper.getRequestURL(sre.getServletRequest()));
    }

    @Override
    public void requestInitialized(final ServletRequestEvent sre) {
        System.out.printf("\nThread %s\tRequest initialized for %s", ListenerHelper.getCurrentThreadName(), ListenerHelper.getRequestURL(sre.getServletRequest()));
    }
}
