package com.javacodegeeks.basics_of_servlets.listeners;

import javax.servlet.annotation.WebListener;
import javax.servlet.http.HttpSessionAttributeListener;
import javax.servlet.http.HttpSessionBindingEvent;

//a web listener that logs the thread and any attribute mutation on the session
@WebListener
public class HttpSessionAttributeMutationListener implements HttpSessionAttributeListener {

    @Override
    public void attributeAdded(final HttpSessionBindingEvent event) {
        System.out.printf("\nThread %s\tSession Attribute added %s", ListenerHelper.getCurrentThreadName(), event.getName());
    }

    @Override
    public void attributeRemoved(final HttpSessionBindingEvent event) {
        System.out.printf("\nThread %s\tSession Attribute removed %s", ListenerHelper.getCurrentThreadName(), event.getName());
    }

    @Override
    public void attributeReplaced(final HttpSessionBindingEvent event) {
        System.out.printf("\nThread %s\tSession Attribute replaced %s", ListenerHelper.getCurrentThreadName(), event.getName());
    }
}
