package com.javacodegeeks.basics_of_servlets.listeners;

import javax.servlet.annotation.WebListener;
import javax.servlet.http.HttpSessionEvent;
import javax.servlet.http.HttpSessionListener;

//a web listener that logs the thread and creation and destruction of any HTTP sessions
@WebListener
public class HttpSessionMutationListener implements HttpSessionListener {

    @Override
    public void sessionCreated(final HttpSessionEvent se) {
        System.out.printf("\nThread %s\tSession created %d", ListenerHelper.getCurrentThreadName(), se.getSession().getId());
    }

    @Override
    public void sessionDestroyed(final HttpSessionEvent se) {
        System.out.printf("\nThread %s\tSession destroyed %d", ListenerHelper.getCurrentThreadName(), se.getSession().getId());
    }
}
