package com.javacodegeeks.basics_of_servlets.listeners;

import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;

import javax.servlet.ServletContextEvent;
import javax.servlet.ServletContextListener;
import javax.servlet.annotation.WebListener;

import com.javacodegeeks.basics_of_servlets.Constants;

//a web listener that creates an ExecutorService on startup and adds it to the servlet context for servlets to use
@WebListener
public class LifecycleServletContextListener implements ServletContextListener {

    @Override
    public void contextInitialized(final ServletContextEvent sce) {
        sce.getServletContext().setAttribute(Constants.THREAD_POOL_EXECUTOR, Executors.newFixedThreadPool(2));
    }

    @Override
    public void contextDestroyed(final ServletContextEvent sce) {
        final ExecutorService executor = (ExecutorService) sce.getServletContext().getAttribute(Constants.THREAD_POOL_EXECUTOR);
        executor.shutdown();
    }
}
