package com.javacodegeeks.basics_of_servlets.listeners;

import javax.servlet.ServletContextAttributeEvent;
import javax.servlet.ServletContextAttributeListener;
import javax.servlet.annotation.WebListener;

//a web listener that logs the thread and any attribute mutations on the servlet context
@WebListener
public class ServletContextAttributeMutationListener implements ServletContextAttributeListener {

    @Override
    public void attributeAdded(ServletContextAttributeEvent event) {
        System.out.printf("\nThread %s\tContext Attribute added %s", ListenerHelper.getCurrentThreadName(), event.getName());
    }

    @Override
    public void attributeRemoved(ServletContextAttributeEvent event) {
        System.out.printf("\nThread %s\tContext Attribute removed %s", ListenerHelper.getCurrentThreadName(), event.getName());
    }

    @Override
    public void attributeReplaced(ServletContextAttributeEvent event) {
        System.out.printf("\nThread %s\tContext Attribute replaced %s", ListenerHelper.getCurrentThreadName(), event.getName());
    }
}
