package com.javacodegeeks.basics_of_servlets.listeners;

import javax.servlet.ServletRequestAttributeEvent;
import javax.servlet.ServletRequestAttributeListener;
import javax.servlet.annotation.WebListener;

//a web listener that logs the thread and any request attribute mutations on the request object
@WebListener
public class ServletRequestAttributeMutationListener implements ServletRequestAttributeListener {

    @Override
    public void attributeAdded(final ServletRequestAttributeEvent srae) {
        System.out.printf("\nThread %s\tRequest Attribute added %s", ListenerHelper.getCurrentThreadName(), srae.getName());
    }

    @Override
    public void attributeRemoved(final ServletRequestAttributeEvent srae) {
        System.out.printf("\nThread %s\tRequest Attribute removed %s", ListenerHelper.getCurrentThreadName(), srae.getName());
    }

    @Override
    public void attributeReplaced(final ServletRequestAttributeEvent srae) {
        System.out.printf("\nThread %s\tRequest Attribute replaced %s", ListenerHelper.getCurrentThreadName(), srae.getName());
    }
}
