package com.javacodegeeks.basics_of_servlets.listeners;

import java.io.IOException;

import javax.servlet.AsyncEvent;
import javax.servlet.AsyncListener;
import javax.servlet.annotation.WebListener;

//a web listener that logs the thread and any of completion, timeout, error and starting of asynchronous processing for asynchronous servlets
@WebListener
public class SnailAsyncListener implements AsyncListener {

    @Override
    public void onComplete(final AsyncEvent event) throws IOException {
        System.out.printf("Thread %s Async request completed for %s ", Thread.currentThread().getName(), ListenerHelper.getRequestURL(event.getSuppliedRequest()));
    }

    @Override
    public void onTimeout(final AsyncEvent event) throws IOException {
        System.out.printf("Thread %s Async request timed out for %s ", Thread.currentThread().getName(), ListenerHelper.getRequestURL(event.getSuppliedRequest()));

    }

    @Override
    public void onError(final AsyncEvent event) throws IOException {
        System.out.printf("Thread %s Async request errored for %s ", Thread.currentThread().getName(), ListenerHelper.getRequestURL(event.getSuppliedRequest()));

    }

    @Override
    public void onStartAsync(final AsyncEvent event) throws IOException {
        System.out.printf("Thread %s Async request started for %s ", Thread.currentThread().getName(), ListenerHelper.getRequestURL(event.getSuppliedRequest()));
    }
}
